# coding: utf-8
#
# Created by David Hargat.
# Copyright © 2017 Giphy. All rights reserved.
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

"""
    giphy-api

    Giphy's public api.

    OpenAPI spec version: 0.9.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class GifImagesPreview(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, mp4=None, mp4_size=None, width=None, height=None):
        """
        GifImagesPreview - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mp4': 'str',
            'mp4_size': 'str',
            'width': 'str',
            'height': 'str'
        }

        self.attribute_map = {
            'mp4': 'mp4',
            'mp4_size': 'mp4_size',
            'width': 'width',
            'height': 'height'
        }

        self._mp4 = mp4
        self._mp4_size = mp4_size
        self._width = width
        self._height = height

    @property
    def mp4(self):
        """
        Gets the mp4 of this GifImagesPreview.
        The URL for this GIF in .MP4 format.

        :return: The mp4 of this GifImagesPreview.
        :rtype: str
        """
        return self._mp4

    @mp4.setter
    def mp4(self, mp4):
        """
        Sets the mp4 of this GifImagesPreview.
        The URL for this GIF in .MP4 format.

        :param mp4: The mp4 of this GifImagesPreview.
        :type: str
        """

        self._mp4 = mp4

    @property
    def mp4_size(self):
        """
        Gets the mp4_size of this GifImagesPreview.
        The size of this file in bytes.

        :return: The mp4_size of this GifImagesPreview.
        :rtype: str
        """
        return self._mp4_size

    @mp4_size.setter
    def mp4_size(self, mp4_size):
        """
        Sets the mp4_size of this GifImagesPreview.
        The size of this file in bytes.

        :param mp4_size: The mp4_size of this GifImagesPreview.
        :type: str
        """

        self._mp4_size = mp4_size

    @property
    def width(self):
        """
        Gets the width of this GifImagesPreview.
        The width of this file in pixels.

        :return: The width of this GifImagesPreview.
        :rtype: str
        """
        return self._width

    @width.setter
    def width(self, width):
        """
        Sets the width of this GifImagesPreview.
        The width of this file in pixels.

        :param width: The width of this GifImagesPreview.
        :type: str
        """

        self._width = width

    @property
    def height(self):
        """
        Gets the height of this GifImagesPreview.
        The height of this file in pixels.

        :return: The height of this GifImagesPreview.
        :rtype: str
        """
        return self._height

    @height.setter
    def height(self, height):
        """
        Sets the height of this GifImagesPreview.
        The height of this file in pixels.

        :param height: The height of this GifImagesPreview.
        :type: str
        """

        self._height = height

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, GifImagesPreview):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
